IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'GRAVA_PEDIDO_XML_NF'
              AND TYPE = 'P'
              AND U.UID = O.UID
              AND U.NAME = USER)

DROP PROCEDURE GRAVA_PEDIDO_XML_NF
GO


CREATE PROCEDURE GRAVA_PEDIDO_XML_NF @P_NRACESSONFE VARCHAR(50),
                                     @P_CDFILIAL VARCHAR(04),
                                     @P_CDOPERADOR VARCHAR(12)
AS
   /* INICIO DA DECLARAO DAS VARIVEIS DO CURSOS C_INTG_SAID_PROD */
   DECLARE @C_INTG_SAID_PROD_NRSEQITPROD VARCHAR(04);
   DECLARE @C_INTG_SAID_PROD_CDPRODUTO VARCHAR(30);
   DECLARE @C_INTG_SAID_PROD_QTITEMPROD DOUBLE PRECISION;
   DECLARE @C_INTG_SAID_PROD_VRUNITITEM DOUBLE PRECISION;
   DECLARE @C_INTG_SAID_PROD_NRPEDIDO VARCHAR(10);
   DECLARE @C_INTG_SAID_PROD_NRITEMPED VARCHAR(10);
   /* FIM DA DECLARAO DAS VARIVEIS DO CURSOS C_INTG_SAID_PROD */

   DECLARE @V_PEDJAUTILIZADO DOUBLE PRECISION;
   DECLARE @V_SEQUENCIAL VARCHAR(20);
   DECLARE @V_CDCLIENTE VARCHAR(21);
   DECLARE @V_CDVENDEDOR VARCHAR(4);
   DECLARE @V_CDMODPGTO VARCHAR(5);
   DECLARE @V_VRNOTAFISC DOUBLE PRECISION;
   DECLARE @V_CDFORNECED VARCHAR(21);
   DECLARE @V_NRINSJURFORN VARCHAR(21);
   DECLARE @V_NRPEDIDO VARCHAR(10);
   DECLARE @V_NRITEMPED VARCHAR(10);
   DECLARE @V_CDPRODUTOFOR VARCHAR(10);
   DECLARE @V_NRNOTAFISC VARCHAR(20);
   DECLARE @V_IDIMPPEDIDO_EXT VARCHAR(01);
   DECLARE @V_CONTADOR VARCHAR(18);
BEGIN
   SELECT @V_PEDJAUTILIZADO = COUNT(*)
     FROM PEDIDO P 
    WHERE P.NRACESSONFE = @P_NRACESSONFE
      AND EXISTS (SELECT NRGRADEPED
                    FROM GRADEPEDIDO G 
                   WHERE P.CDFILIAL = G.CDFILIAL
                     AND P.NRPEDIDO = G.NRPEDIDO);
   
   IF @V_PEDJAUTILIZADO = 0 BEGIN
   
      SELECT @V_CDCLIENTE = NF.CDCLIENTE,
             @V_NRINSJURFORN = NF.NRINSJURNF,
             @V_NRNOTAFISC = NF.NRNOTAFISC
        FROM INTG_SAID_NF NF
       WHERE NF.NRACESSONFS = @P_NRACESSONFE;

      SELECT @V_CDFORNECED = CDFORNECED,
             @V_IDIMPPEDIDO_EXT = ISNULL(IDIMPPEDIDO_EXT, 'N')
        FROM FORNECEDOR
       WHERE NRINSJURFORN = @V_NRINSJURFORN;

      IF @V_IDIMPPEDIDO_EXT = 'N' BEGIN

         DELETE
           FROM PEDIDO
          WHERE NRACESSONFE = @P_NRACESSONFE;

         SELECT @V_CDVENDEDOR = P.CDVENDEDOR,
                @V_CDMODPGTO = P.CDMODPGTO
           FROM PARAMPEDIDO P
          WHERE P.CDFILIAL = @P_CDFILIAL;

         SELECT @V_NRPEDIDO = MAX(PR.NRPEDIDO),
                @V_NRITEMPED = MAX(PR.NRITEMPED)
           FROM INTG_SAID_PROD PR
          WHERE PR.NRACESSONFS = @P_NRACESSONFE;

         SET @V_CONTADOR = 'PEDIDO' + @P_CDFILIAL;
         EXEC NOVO_CODIGO_SC @V_CONTADOR, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT;
         SET @V_SEQUENCIAL = SUBSTRING(@V_SEQUENCIAL, 11, 10);

         INSERT INTO PEDIDO
            (NRPEDIDO, CDCLIENTE, CDFILIAL, CDVENDEDOR,
             DTPEDIDO, DTENTPED, IDPRIOPED, DTHRLANPED,
             CDOPELANPED, IDSITPEDIDO, CDMODPGTO, VRPLIQVOLPED,
             IDTIPOPEDIDO, CDTIPOOPER, IDENTRSAIDOP, CDFORNECEDPED,
             NRPEDIDO_PROT, NRSEQPEDIDO_PROT, DSPEDCLI, NRACESSONFE)
         VALUES(@V_SEQUENCIAL, @V_CDCLIENTE, @P_CDFILIAL, @V_CDVENDEDOR,
                CONVERT(DATE, GETDATE(), 101), CONVERT(DATE, GETDATE(), 101), '2', GETDATE(),
                @P_CDOPERADOR, '2', @V_CDMODPGTO, @V_VRNOTAFISC,
                '1', '01', 'S', @V_CDFORNECED,
                @V_NRPEDIDO, @V_NRITEMPED, 'NF: '+@V_NRNOTAFISC, @P_NRACESSONFE);

         DECLARE C_INTG_SAID_PROD CURSOR FOR SELECT NRSEQITPROD, CDPRODUTO, QTITEMPROD, VRUNITITEM,
                                                    NRPEDIDO, NRITEMPED
                                               FROM INTG_SAID_PROD PR
                                              WHERE PR.NRACESSONFS = @P_NRACESSONFE
         OPEN C_INTG_SAID_PROD;
         FETCH NEXT FROM C_INTG_SAID_PROD INTO @C_INTG_SAID_PROD_NRSEQITPROD, 
                                               @C_INTG_SAID_PROD_CDPRODUTO, 
                                               @C_INTG_SAID_PROD_QTITEMPROD, 
                                               @C_INTG_SAID_PROD_VRUNITITEM,
                                               @C_INTG_SAID_PROD_NRPEDIDO,
                                               @C_INTG_SAID_PROD_NRITEMPED;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_CDPRODUTOFOR = CDPRODUTO
              FROM PRODFORNXML PX
             WHERE PX.CDFORNECED = @V_CDFORNECED
               AND PX.CDPRODUTOXML = @C_INTG_SAID_PROD_CDPRODUTO;
            
            INSERT INTO ITEMPEDIDO
               (NRPEDIDO, CDPRODUTO, QTITEMPED, VRPREUNITPED,
                NRITEMPED, IDSITITEMPED, CDFILIAL, CDOPERADOR,
                QTEXPITEMPED, NRPEDIDO_PROT)
            VALUES
               (@V_SEQUENCIAL, @V_CDPRODUTOFOR, @C_INTG_SAID_PROD_QTITEMPROD, @C_INTG_SAID_PROD_VRUNITITEM,
                @C_INTG_SAID_PROD_NRSEQITPROD, '3', @P_CDFILIAL, @P_CDOPERADOR,
                0, @C_INTG_SAID_PROD_NRPEDIDO);
            
            FETCH NEXT FROM C_INTG_SAID_PROD INTO @C_INTG_SAID_PROD_NRSEQITPROD, 
                                                  @C_INTG_SAID_PROD_CDPRODUTO, 
                                                  @C_INTG_SAID_PROD_QTITEMPROD, 
                                                  @C_INTG_SAID_PROD_VRUNITITEM,
                                                  @C_INTG_SAID_PROD_NRPEDIDO,
                                                  @C_INTG_SAID_PROD_NRITEMPED;
         END;
         CLOSE C_INTG_SAID_PROD;
         DEALLOCATE C_INTG_SAID_PROD;

         UPDATE INTG_SAID_NF
            SET IDPEDIDOGERADO = 'S'
          WHERE NRACESSONFS = @P_NRACESSONFE;
         
         COMMIT;

      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_PEDIDO_XML_NF','6.05.xxx';
GO
